#ifndef __FDLIST_H__
#define __FDLIST_H__

#include "config.h"

#include <string.h>
/*
#include <poll.h>
*/

typedef struct pollfd		FDLIST_POLLFD;

#define FDLIST_FLAGS_READ	0x001
#define FDLIST_FLAGS_WRITE	0x002

typedef struct _fdlist		FDLIST;
typedef struct _fdlistinfo	FDLISTINFO;

struct _fdlist
{
	FDLIST_POLLFD	*pfd_array;
	int				pfd_size;
	int				pfd_num;
};

struct _fdlistinfo
{
    int             fd;
    FDLIST          *fdlist;
    int             fdlist_pos;
};

#define FDLIST_FD(__fdlist, __pos)	(__fdlist)->pfd_array[(__pos)].fd

#define SET_FDS(__fd, __ptr)	Fds[(__fd)] = (__ptr)
#define GET_FDS(__fd)			Fds[(__fd)]

#define fdlist_events(__fdlist, __pos)	(__fdlist)->pfd_array[(__pos)].events
#define fdlist_init(__fdlist)	memset((__fdlist), 0, sizeof(FDLIST))

int fdlist_add_fd(FDLIST *fdlist, int fd, int flags);
int fdlist_del_fd(FDLIST *fdlist, int pos, int *mfd);
int fdlist_add_event(FDLIST *fdlist, int pos, int flags);
int fdlist_del_event(FDLIST *fdlist, int pos, int flags);
int fdlist_set_events(FDLIST *fdlist, int pos, int flags);
int fdlist_get_events(FDLIST *fdlist, int pos);

#endif
