#ifndef __FILEIO_H__
#define __FILEIO_H__

#include <sys/types.h>
#include <sys/stat.h>

#define FB_EOF  0x01
#define FB_FAIL 0x02

#define FB_INBUFFER		1
#define FB_OUTBUFFER	2

struct FileBuf {
	int		fd;			/* file descriptor */
	char	*buf;		/* input buffer */
	int		inbufsize;	/* input buffer size */
	char	*endp;		/* one past the end */
	char	*ptr;		/* current read pos */
	char	*outbuf;	/* output buffer */
	int		outbufsize;	/* output buffer size */
	int		outbufpos;	/* cur position in output buffer */
	pid_t	pid;		/* used for piped filebufs */
	u_char	flags;
};

typedef struct FileBuf aFileBuf;

aFileBuf	*fbopen(const char *filename, const char* mode);
void		fbclose(aFileBuf *fb);
int			fbgetc(aFileBuf *fb);
char		*fbgets(char* buf, size_t len, aFileBuf* fb);
int			fbputs(const char *str, aFileBuf *fb);
int			fbstat(struct stat *sb, aFileBuf *fb);
aFileBuf	*fbopenp(const char *ename, const char *arg1, const char *arg2);
pid_t		fbpid(aFileBuf *fb);
int			fbsetbuf(aFileBuf *fb, int which, int size);
int			fbwrite(aFileBuf *fb, const void *buffer, int size);
int			fbflush(aFileBuf *fb);

#endif /* __FILEIO_H__ */
