#ifndef __HASH_H__
#define __HASH_H__

#include "structs.h"

#define HASH_CLIENT_SIZE	(64*1024)
#define HASH_CHANNEL_SIZE	(24*1024)
#define HASH_WHOWAS_SIZE	(32*1024)
#define HASH_IP_SIZE		(1024)

void hash_init(void);
unsigned int hash_compute_whowas(char *nname);
IRCD_CLIENT *hash_find_client(char *name);
IRCD_CLIENT *hash_find_chasing(char *name);
IRCD_CLIENT *hash_find_client_incl_hm(char *name);
IRCD_CHANNEL *hash_find_channel(char *name);
int hash_add_client(IRCD_CLIENT *cptr);
int hash_del_client(IRCD_CLIENT *cptr);
int hash_add_channel(IRCD_CHANNEL *chptr);
int hash_del_channel(IRCD_CHANNEL *chptr);
void add_auth_to_alist(IRCD_AUTH **bucket, IRCD_AUTH *auth);
void del_auth_from_alist(IRCD_AUTH **bucket, IRCD_AUTH *auth);
void add_rejecthold_to_rhlist(IRCD_REJECTHOLD **bucket, IRCD_REJECTHOLD *rejecthold);
void del_rejecthold_from_rhlist(IRCD_REJECTHOLD **bucket, IRCD_REJECTHOLD *rejecthold);
void add_listener_to_llist(IRCD_LISTENER **bucket, IRCD_LISTENER *listener);
void del_listener_from_llist(IRCD_LISTENER **bucket, IRCD_LISTENER *listener);
void add_client_to_ilist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void del_client_from_ilist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void add_client_to_nlist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void del_client_from_nlist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void add_client_to_llist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void del_client_from_llist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void add_conn_to_llist(IRCD_CONN **bucket, IRCD_CONN *conn);
void del_conn_from_llist(IRCD_CONN **bucket, IRCD_CONN *conn);
void add_client_to_lolist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void del_client_from_lolist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void add_client_to_cllist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void del_client_from_cllist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void add_client_to_oslist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void del_client_from_oslist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void add_client_to_ulist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void del_client_from_ulist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void add_client_to_flist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void del_client_from_flist(IRCD_CLIENT **bucket, IRCD_CLIENT *client);
void add_clientlist_to_list(IRCD_CLIENTLIST **bucket, IRCD_CLIENTLIST *clientlist);
void del_clientlist_from_list(IRCD_CLIENTLIST **bucket, IRCD_CLIENTLIST *clientlist);
void add_channellist_to_list(IRCD_CHANNELLIST **bucket, IRCD_CHANNELLIST *channellist);
void del_channellist_from_list(IRCD_CHANNELLIST **bucket, IRCD_CHANNELLIST *channellist);
void add_invite_to_list(IRCD_INVITE **bucket, IRCD_INVITE *invite);
void del_invite_from_list(IRCD_INVITE **bucket, IRCD_INVITE *invite);
void add_ban_to_list(IRCD_BAN **bucket, IRCD_BAN *ban);
void del_ban_from_list(IRCD_BAN **bucket, IRCD_BAN *ban);
void add_reqlist_to_list(IRCDRES_REQLIST **bucket, IRCDRES_REQLIST *reqlist);
void del_reqlist_from_list(IRCDRES_REQLIST **bucket, IRCDRES_REQLIST *reqlist);
int hash_init_reload(void **client_hash, int client_hash_size, void **channel_hash, int channel_hash_size);
int hash_deinit_reload(void ***client_hash, int *client_hash_size, void ***channel_hash, int *channel_hash_size);


#endif
