#ifndef __IRCD_INCLUDES_H__
#define __IRCD_INCLUDES_H__

#include "setup.h"

#include <assert.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#ifdef HAVE_CRYPT_H
#include <crypt.h>
#endif
#ifdef HAVE_STROPTS_H
#include <stropts.h>
#endif
#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif
#include <stdarg.h>
#ifdef HAVE_SYS_FILIO_H
#include <sys/filio.h>
#endif
#include <stdlib.h>
#include <stddef.h>
#include <ctype.h>
#include <string.h>
#include <strings.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <signal.h>
#include <syslog.h>
#include <time.h>
#ifdef HAVE_POLL
#include <poll.h>
#else
#define USE_SUPPORT_POLL
#endif
#include <sys/time.h>
#include <sys/resource.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>

#ifndef HAVE_STRERROR
#ifndef SYS_ERRLIST_DECLARED
extern char		*sys_errlist[];
extern int		sys_nerr;
#endif
#endif

#include "defines.h"
#include "match.h"

#include "support.h"
#include "config.h"

#include "fdlist.h"
#include "queue.h"
#include "fileio.h"
#include "conf.h"
#include "structs.h"
#include "cidr.h"
#include "access.h"
#include "misc.h"
#include "mysocket.h"
#include "res.h"
#include "hash.h"
#include "whowas.h"
#include "send.h"
#include "numeric.h"
#include "vars.h"
#include "version.h"
#include "iphash.h"

#endif
