#ifndef __QUEUE_H__
#define __QUEUE_H__

#define IQUEUE_FLAGS_USEMMAP	0x001

typedef struct _iqueue	IQUEUE;
typedef struct _iqentry	IQENTRY;

struct _iqueue
{
	int			flags;
	int			entrysize;

	int			queue_size;
	IQENTRY		*entries;
	IQENTRY		*last_entry;
};

struct _iqentry
{
	int			flags;

	char		*buffer;
	int			curpos;
	int			buflen;
	int			bufsize;
	IQENTRY		*next;
};

int queue_init(IQUEUE *queue, int entrysize, int flags);
int queue_data_add(IQUEUE *queue, char *data, int datalen);
int queue_data_get(IQUEUE *queue, char **data, int *datalen);
int queue_delete(IQUEUE *queue);
int queue_data_del(IQUEUE *queue, int datalen);
int queue_data_get_nl(IQUEUE *queue, char *buffer, int buflen, int flags);
int queue_cleanup(void);
int queue_resize(IQUEUE *queue, int newsize);
int queue_get_stats(int *queue_sizes, int *queue_fl_sizes, int *queue_malloced_sizes);
int queue_set_stats(int queue_sizes, int queue_malloced_size);

#endif
