#ifndef __SUPPORT_H__
#define __SUPPORT_H__

#define MyFree(__x)			support_free((__x))
#define MyMalloc(__x)		support_malloc((__x))
#define MyRealloc(__x, __y)	support_realloc((__x), (__y))
#define MyStrdup(__x)		support_strdup((__x))

#ifdef BOUNDSCHECKING

#define BCOPY(__a, __b, __c)	memmove((__b), (__a), (__c))
#define BZERO	bzero
#define BCMP	bcmp

#else

#if 1
/* leave out type casts for now */
#define BCOPY(__x, __y, __z) support_bcopy((__x), (__y), (__z))
#define BCMP(__x, __y, __z)	support_bcmp((__x), (__y), (__z))
#define BZERO(__x, __y)		support_bzero((__x), (__y))
#else
#define BCOPY(__x, __y, __z) support_bcopy((void *)(__x), (void *)(__y), (__z))
#define BCMP(__x, __y, __z)	support_bcmp((void *)(__x), (void *)(__y), (__z))
#define BZERO(__x, __y)		support_bzero((void *)(__x), (__y))
#endif

#endif

#ifdef USE_SUPPORT_POLL

struct pollfd
{
	int		fd;
	int		events;
	int		revents;
};

#define POLLIN	0x0001
#define POLLOUT	0x0004

#define poll support_poll

#endif

int ircd_getpagesize(void);
void support_free(void *ptr);
void support_free_dbg(void *ptr, char *filename, int lineno);
void *support_malloc(size_t len);
void *support_realloc(void *ptr, size_t len);
char *support_strdup(char *string);
void support_bcopy(const void *, void *, size_t);
int support_bcmp(const void *s1, const void *s2, size_t n);
void support_bzero(void *s, size_t n);
char *support_strncpy(char *dest, char *src, int len);
char *support_stristr(char *str1, char *str2);
char *support_ctime(int thetime);
char *support_strerror(int errnum);
#ifdef USE_SUPPORT_POLL
int support_poll(struct pollfd *pfd, int npfds, int timeout);
#endif

#endif
